import java.util.*;

public class WaifValidator 
{
	public static void main(String[] args) throws Exception
	{
		Scanner scan = new Scanner(System.in);
		
		int numChildren = scan.nextInt();
		int numToys = scan.nextInt();
		int numCategories = scan.nextInt();
		
		if (numChildren < 1 || numChildren > 100)
		{
			throw new Exception("Illegal number of children");
		}
		
		if (numToys < 1 || numToys > 100)
		{
			throw new Exception("Illegal number of toys");
		}
		
		if (numCategories < 0 || numCategories > numToys)
		{
			throw new Exception("Illegal number of toy categories");
		}
		
		for (int i = 0; i < numChildren; i++)
		{
			int numLikedToys = scan.nextInt();
			if (numLikedToys < 1 || numLikedToys > numToys + 1)
			{
				throw new Exception("Darling likes illegal number of toys at " + numLikedToys);
			}
			
			HashSet<Integer> seen = new HashSet<Integer>();
			for (int j = 0; j < numLikedToys; j++)
			{
				int likedToyIndex = scan.nextInt();
				if (likedToyIndex < 1 || likedToyIndex > numToys + 1)
				{
					throw new Exception("Darling likes illegal toy number " + likedToyIndex);
				}
				
				if (seen.contains(likedToyIndex))
				{
					throw new Exception("Darling likes the same toy twice, at index " + likedToyIndex);
				}
				
				seen.add(likedToyIndex);
			}
		}
		
		for (int i = 0; i < numCategories; i++)
		{
			int l = scan.nextInt();
			HashSet<Integer> seen = new HashSet<Integer>();
			
			for (int j = 0; j < l; j++)
			{
				int toy = scan.nextInt();
				if (toy < 1 || toy > numToys)
				{
					throw new Exception("Illegal toy index in category");
				}
				
				if (seen.contains(toy))
				{
					throw new Exception("Same toy in the same category");
				}
				
				seen.add(toy);
			}
			
			int r = scan.nextInt();
			if (r < 1 || r > l)
			{
				throw new Exception("Illegal number of toys allowed to be used from a category");
			}
		}
		
		if (scan.hasNext())
		{
			throw new Exception("Excess data in input");
		}
System.exit(42);
	}
}
